diff --git a/SHADE_Engine/src/Graphics/RenderGraph/SHRenderGraphResource.h b/SHADE_Engine/src/Graphics/RenderGraph/SHRenderGraphResource.h
index 66f0677b..efaf9bf5 100644
--- a/SHADE_Engine/src/Graphics/RenderGraph/SHRenderGraphResource.h
+++ b/SHADE_Engine/src/Graphics/RenderGraph/SHRenderGraphResource.h
@@ -16,6 +16,8 @@ namespace SHADE
   class SHVkCommandBuffer;
   class SHVkBuffer;
 
+  static constexpr uint32_t NON_SWAPCHAIN_RESOURCE_INDEX = 0;
+
   class SH_API SHRenderGraphResource
   {
   private:
@@ -32,7 +34,7 @@ namespace SHADE
     std::string resourceName;
 
     //! Used for initializing image layouts
-    SH_ATT_DESC_TYPE resourceType;
+    SHRenderGraphResourceFlags resourceTypeFlags;
 
     //! The resource itself (this is a vector because if the resource happens
     //! to be a swapchain image, then we need however many frames in flight). 
@@ -67,7 +69,7 @@ namespace SHADE
     /*-----------------------------------------------------------------------*/
     /* CTORS AND DTORS                                                       */
     /*-----------------------------------------------------------------------*/
-    SHRenderGraphResource(Handle<SHVkLogicalDevice> const& logicalDevice, Handle<SHVkSwapchain> const& swapchain, std::string const& name, SH_ATT_DESC_TYPE type, vk::Format format, uint32_t w, uint32_t h, uint8_t levels, vk::ImageUsageFlagBits usageFlags, vk::ImageCreateFlagBits createFlags) noexcept;
+    SHRenderGraphResource(Handle<SHVkLogicalDevice> const& logicalDevice, Handle<SHVkSwapchain> const& swapchain, std::string const& name, std::initializer_list<SH_ATT_DESC_TYPE_FLAGS> typeFlags, vk::Format format, uint32_t w, uint32_t h, uint8_t levels, vk::ImageUsageFlagBits usageFlags, vk::ImageCreateFlagBits createFlags) noexcept;
     SHRenderGraphResource(SHRenderGraphResource&& rhs) noexcept;
     SHRenderGraphResource& operator=(SHRenderGraphResource&& rhs) noexcept;
     ~SHRenderGraphResource(void) noexcept;
@@ -82,9 +84,10 @@ namespace SHADE
     /*-----------------------------------------------------------------------*/
     /* SETTERS AND GETTERS                                                   */
     /*-----------------------------------------------------------------------*/
-    vk::Format GetResourceFormat (void) const noexcept;
-    uint32_t   GetWidth          (void) const noexcept;
-    uint32_t   GetHeight         (void) const noexcept;
+    vk::Format            GetResourceFormat (void) const noexcept;
+    uint32_t              GetWidth          (void) const noexcept;
+    uint32_t              GetHeight         (void) const noexcept;
+    Handle<SHVkImageView> GetImageView      (uint32_t index = NON_SWAPCHAIN_RESOURCE_INDEX) const noexcept;
 
     friend class SHRenderGraphNode;
     friend class SHRenderGraph;
diff --git a/SHADE_Engine/src/Graphics/RenderGraph/SHSubpass.cpp b/SHADE_Engine/src/Graphics/RenderGraph/SHSubpass.cpp
index abd3a7be..ffbe4ff0 100644
--- a/SHADE_Engine/src/Graphics/RenderGraph/SHSubpass.cpp
+++ b/SHADE_Engine/src/Graphics/RenderGraph/SHSubpass.cpp
@@ -23,7 +23,7 @@ namespace SHADE
 
   */
   /***************************************************************************/
-  SHSubpass::SHSubpass(ResourceManager& rm, Handle<SHRenderGraphNode> const& parent, uint32_t index, std::unordered_map<uint64_t, uint32_t> const* mapping, std::unordered_map<std::string, Handle<SHRenderGraphResource>> const* resources) noexcept
+  SHSubpass::SHSubpass(Handle<SHRenderGraphNode> const& parent, uint32_t index, std::unordered_map<uint64_t, uint32_t> const* mapping, std::unordered_map<std::string, Handle<SHRenderGraphResource>> const* resources) noexcept
     : resourceAttachmentMapping{ mapping }
     , ptrToResources{ resources }
     , parentNode{ parent }
@@ -55,6 +55,8 @@ namespace SHADE
     , inputReferences{ std::move(rhs.inputReferences) }
     , resourceAttachmentMapping{ rhs.resourceAttachmentMapping }
     , ptrToResources{ rhs.ptrToResources }
+    , descriptorSetLayout{ rhs.descriptorSetLayout }
+    , exteriorDrawCalls{ std::move (rhs.exteriorDrawCalls) }
   {
 
   }
@@ -83,6 +85,8 @@ namespace SHADE
     inputReferences = std::move(rhs.inputReferences);
     resourceAttachmentMapping = rhs.resourceAttachmentMapping;
     ptrToResources = rhs.ptrToResources;
+    descriptorSetLayout = rhs.descriptorSetLayout;
+    exteriorDrawCalls = std::move(rhs.exteriorDrawCalls);
 
     return *this;
   }
@@ -120,18 +124,18 @@ namespace SHADE
 
   */
   /***************************************************************************/
-  void SHSubpass::AddDepthOutput(std::string resourceToReference, SH_ATT_DESC_TYPE attachmentDescriptionType) noexcept
+  void SHSubpass::AddDepthOutput(std::string resourceToReference, SH_ATT_DESC_TYPE_FLAGS attachmentDescriptionType) noexcept
   {
     vk::ImageLayout imageLayout;
     switch (attachmentDescriptionType)
     {
-    case SH_ATT_DESC_TYPE::DEPTH:
+    case SH_ATT_DESC_TYPE_FLAGS::DEPTH:
       imageLayout = vk::ImageLayout::eDepthAttachmentOptimal;
       break;
-    case SH_ATT_DESC_TYPE::STENCIL:
+    case SH_ATT_DESC_TYPE_FLAGS::STENCIL:
       imageLayout = vk::ImageLayout::eStencilAttachmentOptimal;
       break;
-    case SH_ATT_DESC_TYPE::DEPTH_STENCIL:
+    case SH_ATT_DESC_TYPE_FLAGS::DEPTH_STENCIL:
       imageLayout = vk::ImageLayout::eDepthStencilAttachmentOptimal;
       break;
     default:
diff --git a/SHADE_Engine/src/Graphics/RenderGraph/SHSubpass.h b/SHADE_Engine/src/Graphics/RenderGraph/SHSubpass.h
index aba282b9..c567a897 100644
--- a/SHADE_Engine/src/Graphics/RenderGraph/SHSubpass.h
+++ b/SHADE_Engine/src/Graphics/RenderGraph/SHSubpass.h
@@ -62,7 +62,7 @@ namespace SHADE
     /*-----------------------------------------------------------------------*/
     /* CTORS AND DTORS                                                       */
     /*-----------------------------------------------------------------------*/
-    SHSubpass(ResourceManager& rm, Handle<SHRenderGraphNode> const& parent, uint32_t index, std::unordered_map<uint64_t, uint32_t> const* mapping, std::unordered_map<std::string, Handle<SHRenderGraphResource>> const* ptrToResources) noexcept;
+    SHSubpass(Handle<SHRenderGraphNode> const& parent, uint32_t index, std::unordered_map<uint64_t, uint32_t> const* mapping, std::unordered_map<std::string, Handle<SHRenderGraphResource>> const* ptrToResources) noexcept;
     SHSubpass(SHSubpass&& rhs) noexcept;
     SHSubpass& operator=(SHSubpass&& rhs) noexcept;
 
@@ -71,7 +71,7 @@ namespace SHADE
     /*-----------------------------------------------------------------------*/
     // Preparation functions
     void AddColorOutput(std::string resourceToReference) noexcept;
-    void AddDepthOutput(std::string resourceToReference, SH_ATT_DESC_TYPE attachmentDescriptionType = SH_ATT_DESC_TYPE::DEPTH_STENCIL) noexcept;
+    void AddDepthOutput(std::string resourceToReference, SH_ATT_DESC_TYPE_FLAGS attachmentDescriptionType = SH_ATT_DESC_TYPE_FLAGS::DEPTH_STENCIL) noexcept;
     void AddInput(std::string resourceToReference) noexcept;
 
     // Runtime functions
diff --git a/SHADE_Engine/src/Graphics/Renderpass/SHVkRenderpass.cpp b/SHADE_Engine/src/Graphics/Renderpass/SHVkRenderpass.cpp
index fee23f13..74128ec8 100644
--- a/SHADE_Engine/src/Graphics/Renderpass/SHVkRenderpass.cpp
+++ b/SHADE_Engine/src/Graphics/Renderpass/SHVkRenderpass.cpp
@@ -253,7 +253,8 @@ namespace SHADE
 
   SHVkRenderpass::~SHVkRenderpass(void) noexcept
   {
-    logicalDeviceHdl->GetVkLogicalDevice().destroyRenderPass(vkRenderpass, nullptr);
+    if (vkRenderpass)
+      logicalDeviceHdl->GetVkLogicalDevice().destroyRenderPass(vkRenderpass, nullptr);
   }
 
 
diff --git a/SHADE_Engine/src/Graphics/SHVulkanDefines.h b/SHADE_Engine/src/Graphics/SHVulkanDefines.h
index 1cbcae0f..a0a6d57c 100644
--- a/SHADE_Engine/src/Graphics/SHVulkanDefines.h
+++ b/SHADE_Engine/src/Graphics/SHVulkanDefines.h
@@ -12,6 +12,7 @@ namespace SHADE
   using BindingAndSetHash = uint64_t;
   using SetIndex = uint32_t;
   using SHSubPassIndex = uint32_t;
+  using SHRenderGraphResourceFlags = uint32_t;
 
 }
 
diff --git a/SHADE_Engine/src/Resource/SparseSet.h b/SHADE_Engine/src/Resource/SparseSet.h
index 8a3f9c6e..fb4a8311 100644
--- a/SHADE_Engine/src/Resource/SparseSet.h
+++ b/SHADE_Engine/src/Resource/SparseSet.h
@@ -59,9 +59,9 @@ namespace SHADE
         SparseSet();
         ~SparseSet() = default;
 
-        // Disallow moving or copying
-        SparseSet(const SparseSet&) = delete;
-        SparseSet(SparseSet&&) = delete;
+        //// Disallow moving or copying
+        //SparseSet(const SparseSet&) = delete;
+        //SparseSet(SparseSet&&) = delete;
 
         /*-----------------------------------------------------------------------------*/
         /* Usage Functions                                                             */
diff --git a/SHADE_Engine/src/Scripting/SHScriptEngine.cpp b/SHADE_Engine/src/Scripting/SHScriptEngine.cpp
index 65f445a6..d7a090a4 100644
--- a/SHADE_Engine/src/Scripting/SHScriptEngine.cpp
+++ b/SHADE_Engine/src/Scripting/SHScriptEngine.cpp
@@ -115,7 +115,7 @@ namespace SHADE
   /*---------------------------------------------------------------------------------*/
   /* Script Serialisation Functions                                                  */
   /*---------------------------------------------------------------------------------*/
-  std::string SHScriptEngine::SerialiseScripts(const SHEntity& entity) const
+  std::string SHScriptEngine::SerialiseScripts(EntityID entity) const
   {
     // Create buffer needed to store serialised script data
     constexpr int BUFFER_SIZE = 10240;
@@ -124,7 +124,7 @@ namespace SHADE
 
     // Attempt to serialise the script
     std::string result;
-    if (csScriptsSerialise(entity.GetEID(), buffer.get(), BUFFER_SIZE))
+    if (csScriptsSerialise(entity, buffer.get(), BUFFER_SIZE))
     {
       result = std::string(buffer.get());
     }
@@ -140,9 +140,9 @@ namespace SHADE
   /*-----------------------------------------------------------------------------------*/
   /* Script Serialisation Functions                                                    */
   /*-----------------------------------------------------------------------------------*/
-  void SHScriptEngine::DeserialiseScript(const SHEntity& entity, const std::string& yaml) const
+  void SHScriptEngine::DeserialiseScript(EntityID entity, const std::string& yaml) const
   {
-    csScriptDeserialise(entity.GetEID(), yaml.c_str());
+    csScriptDeserialise(entity, yaml.c_str());
   }
 
   /*-----------------------------------------------------------------------------------*/
diff --git a/SHADE_Engine/src/Scripting/SHScriptEngine.h b/SHADE_Engine/src/Scripting/SHScriptEngine.h
index 239d6b90..60723425 100644
--- a/SHADE_Engine/src/Scripting/SHScriptEngine.h
+++ b/SHADE_Engine/src/Scripting/SHScriptEngine.h
@@ -148,7 +148,7 @@ namespace SHADE
     /// <returns>
     /// String that represents the set of scripts attached to the specified Entity.
     /// </returns>
-    std::string SerialiseScripts(const SHEntity& entity) const;
+    std::string SerialiseScripts(EntityID entity) const;
     /// <summary>
     /// Loads the specified JSON string and creates a Script for the specified Entity
     /// based on the specified JSON string.
@@ -157,7 +157,7 @@ namespace SHADE
     /// <param name="yaml">
     /// The YAML string that represents the Script to load into the Entity.
     /// </param>
-    void DeserialiseScript(const SHEntity& entity, const std::string& yaml) const;
+    void DeserialiseScript(EntityID entity, const std::string& yaml) const;
 
     /*-----------------------------------------------------------------------------*/
     /* Script Editor Functions                                                     */
diff --git a/SHADE_Engine/src/Serialization/SHSerialization.cpp b/SHADE_Engine/src/Serialization/SHSerialization.cpp
new file mode 100644
index 00000000..e259fbbc
--- /dev/null
+++ b/SHADE_Engine/src/Serialization/SHSerialization.cpp
@@ -0,0 +1,220 @@
+#include "SHpch.h"
+#include "SHSerializationHelper.hpp"
+#include "SHSerialization.h"
+
+#include <yaml-cpp/yaml.h>
+
+#include "ECS_Base/Managers/SHEntityManager.h"
+#include "Scene/SHSceneManager.h"
+#include "Tools/SHException.h"
+#include "Assets/SHAssetManager.h"
+#include <fstream>
+
+#include "Graphics/MiddleEnd/Interface/SHRenderable.h"
+#include "Math/Transform/SHTransformComponent.h"
+#include "Physics/Components/SHRigidBodyComponent.h"
+
+namespace SHADE
+{
+  void SHSerialization::SerializeSceneToFile(std::filesystem::path const& path)
+  {
+    YAML::Emitter out;
+    SerializeSceneToEmitter(out);
+    std::ofstream file(path.c_str());
+    if (file.good())
+    {
+      file << out.c_str();
+      file.close();
+    }
+  }
+
+  std::string SHSerialization::SerializeSceneToString()
+  {
+    YAML::Emitter out;
+    SerializeSceneToEmitter(out);
+    return std::basic_string<char>(out.c_str());
+  }
+
+  void SHSerialization::SerializeSceneToEmitter(YAML::Emitter& out)
+  {
+    auto const& sceneGraph = SHSceneManager::GetCurrentSceneGraph();
+    auto root = sceneGraph.GetRoot();
+
+    SHASSERT(root != nullptr, "Root is null. Failed to serialize scene to node.");
+
+    auto const& children = root->GetChildren();
+    out << YAML::BeginSeq;
+
+    auto pred = [&out](SHSceneNode* node) {out << SerializeEntityToNode(node); };
+    sceneGraph.Traverse(pred);
+    //out << SerializeEntityToNode(child);
+
+    out << YAML::EndSeq;
+  }
+
+  static void DeserializeEntity(YAML::iterator& it, YAML::Node const& node, std::vector<EntityID>& createdEntities, EntityID parentEID = MAX_EID)
+  {
+    if (!node[EIDNode])
+      return;
+    EntityID eid = node[EIDNode].as<EntityID>();
+    std::string name = "Default";
+    if (node[EntityNameNode])
+      name = node[EntityNameNode].as<std::string>();
+    //Compile component IDs
+    const auto componentIDList = SHSerialization::GetComponentIDList(node[ComponentsNode]);
+    eid = SHEntityManager::CreateEntity(componentIDList, eid, name, parentEID);
+    createdEntities.push_back(eid);
+    if (node[NumberOfChildrenNode])
+    {
+      if(const int numOfChildren = node[NumberOfChildrenNode].as<int>(); numOfChildren > 0)
+      {
+        ++it;
+        for (int i = 0; i < numOfChildren; ++i)
+        {
+          DeserializeEntity(it, (*it), createdEntities, eid);
+          if((i + 1) < numOfChildren)
+            ++it;
+        }
+      }
+    }
+  }
+
+  void SHSerialization::DeserializeSceneFromFile(std::filesystem::path const& path)
+  {
+    //TODO:Shift to using XQ's FileIO
+    std::ifstream iFile;
+    iFile.exceptions(std::ifstream::failbit | std::ifstream::badbit);
+    std::string fileContent = "";
+
+    try
+    {
+      // Open file
+      // Read file's buffer contents into streams
+      iFile.open(path);
+      std::stringstream fileStream;
+      fileStream << iFile.rdbuf();
+
+      fileContent = fileStream.str();
+
+      // Close file handler
+      iFile.close();
+    }
+    catch (std::ifstream::failure e)
+    {
+      SHLOG_ERROR("Could not read file");
+    }
+    YAML::Node entities = YAML::Load(fileContent);
+    std::vector<EntityID> createdEntities{};
+
+    //Create Entities
+    for (auto it = entities.begin(); it != entities.end(); ++it)
+    {
+      DeserializeEntity(it, (*it), createdEntities);
+    }
+
+    //Initialize Entity
+    auto entityVecIt = createdEntities.begin();
+    for (auto it = entities.begin(); it != entities.end(); ++it)
+    {
+      InitializeEntity(*it, *entityVecIt++);
+    }
+  }
+
+  void SHSerialization::EmitEntity(SHSceneNode* entityNode, YAML::Emitter& out)
+  {
+    out << SerializeEntityToNode(entityNode);
+    auto const& children = entityNode->GetChildren();
+    for(auto const& child : children)
+    {
+      EmitEntity(child, out);
+    }
+  }
+
+  std::string SHSerialization::SerializeEntitiesToString(std::vector<EntityID> const& entities)
+  {
+    YAML::Emitter out;
+    YAML::Node node;
+    auto const& sceneGraph = SHSceneManager::GetCurrentSceneGraph();
+    for (auto const& eid : entities)
+    {
+      auto entityNode = sceneGraph.GetNode(eid);
+      EmitEntity(entityNode, out);
+    }
+    return std::basic_string<char>(out.c_str());
+  }
+
+  void SHSerialization::SerializeEntityToFile(std::filesystem::path const& path)
+  {
+  }
+
+  YAML::Node SHSerialization::SerializeEntityToNode(SHSceneNode* sceneNode)
+  {
+    YAML::Node node;
+    auto eid = sceneNode->GetEntityID();
+    auto entity = SHEntityManager::GetEntityByID(eid);
+    if (!sceneNode || !entity)
+    {
+      node = YAML::Null;
+      return node;
+    }
+    node.SetStyle(YAML::EmitterStyle::Block);
+    node[EIDNode] = eid;
+    node[EntityNameNode] = entity->name;
+    node[IsActiveNode] = sceneNode->IsActive();
+    auto const& children = sceneNode->GetChildren();
+    node[NumberOfChildrenNode] = children.size();
+
+    YAML::Node components;
+
+    if (const auto transform = SHComponentManager::GetComponent_s<SHTransformComponent>(eid))
+    {
+      components[rttr::type::get<SHTransformComponent>().get_name().data()] = SHSerializationHelper::SerializeComponentToNode(transform);
+    }
+    if (const auto renderable = SHComponentManager::GetComponent_s<SHRenderable>(eid))
+    {
+      components[rttr::type::get<SHRenderable>().get_name().data()] = SHSerializationHelper::SerializeComponentToNode(renderable);
+    }
+    if (const auto rigidbody = SHComponentManager::GetComponent_s<SHRigidBodyComponent>(eid))
+    {
+      components[rttr::type::get<SHRigidBodyComponent>().get_name().data()] = SHSerializationHelper::SerializeComponentToNode(rigidbody);
+    }
+    node[ComponentsNode] = components;
+    return node;
+  }
+
+  template<typename ComponentType, std::enable_if_t<std::is_base_of_v<SHComponent, ComponentType>, bool> = true>
+  std::optional<ComponentTypeID> GetComponentID(YAML::Node const& componentNode)
+  {
+    if (componentNode[rttr::type::get<ComponentType>().get_name().data()])
+      return { SHFamilyID<SHComponent>::GetID<ComponentType>() };
+    else
+      return std::nullopt;
+  }
+
+  std::vector<ComponentTypeID> SHSerialization::GetComponentIDList(YAML::Node const& componentsNode)
+  {
+    std::vector<ComponentTypeID> componentIDList;
+
+    auto id = GetComponentID<SHTransformComponent>(componentsNode);
+    if (id.has_value())
+      componentIDList.push_back(id.value());
+
+    id = GetComponentID<SHRenderable>(componentsNode);
+    if (id.has_value())
+      componentIDList.push_back(id.value());
+
+    id = GetComponentID<SHRigidBodyComponent>(componentsNode);
+    if (id.has_value())
+      componentIDList.push_back(id.value());
+
+    return componentIDList;
+  }
+
+  void SHSerialization::InitializeEntity(YAML::Node const& entityNode, EntityID const& eid)
+  {
+    auto const componentsNode = entityNode[ComponentsNode];
+    if (!componentsNode)
+      return;
+    SHSerializationHelper::InitializeComponentFromNode<SHTransformComponent>(componentsNode, eid);
+  }
+}
diff --git a/SHADE_Engine/src/Serialization/SHSerialization.h b/SHADE_Engine/src/Serialization/SHSerialization.h
new file mode 100644
index 00000000..d247de7a
--- /dev/null
+++ b/SHADE_Engine/src/Serialization/SHSerialization.h
@@ -0,0 +1,43 @@
+#pragma once
+
+#include "SH_API.h"
+#include <string>
+#include <filesystem>
+
+#include <ECS_Base/Components/SHComponent.h>
+
+namespace YAML
+{
+  class Emitter;
+  class Node;
+}
+
+namespace SHADE
+{
+  class SHSceneNode;
+
+  constexpr const char* ComponentsNode = "Components";
+  constexpr const char* EntityNameNode = "Name";
+  constexpr const char* EIDNode = "EID";
+  constexpr const char* IsActiveNode = "IsActive";
+  constexpr const char* NumberOfChildrenNode = "NumberOfChildren";
+
+  struct SH_API SHSerialization
+  {
+    //TODO: change paths to resource ID
+    static void SerializeSceneToFile(std::filesystem::path const& path);
+    static std::string SerializeSceneToString();
+    static void SerializeSceneToEmitter(YAML::Emitter& out);
+    static void DeserializeSceneFromFile(std::filesystem::path const& path);
+    
+    
+    static void EmitEntity(SHSceneNode* entityNode, YAML::Emitter& out);
+    static std::string SerializeEntitiesToString(std::vector<EntityID> const& entities);
+    static void SerializeEntityToFile(std::filesystem::path const& path);
+    static YAML::Node SerializeEntityToNode(SHSceneNode* sceneNode);
+
+    static std::vector<ComponentTypeID> GetComponentIDList(YAML::Node const& componentsNode);
+  private:
+    static void InitializeEntity(YAML::Node const& entityNode, EntityID const& eid);
+  };
+}
\ No newline at end of file
diff --git a/SHADE_Engine/src/Serialization/SHSerializationHelper.hpp b/SHADE_Engine/src/Serialization/SHSerializationHelper.hpp
new file mode 100644
index 00000000..da98c885
--- /dev/null
+++ b/SHADE_Engine/src/Serialization/SHSerializationHelper.hpp
@@ -0,0 +1,204 @@
+#pragma once
+
+#include "ECS_Base/Components/SHComponent.h"
+#include <yaml-cpp/yaml.h>
+
+#include <rttr/registration>
+
+#include "ECS_Base/Managers/SHComponentManager.h"
+#include "Math/Vector/SHVec2.h"
+#include "Math/Vector/SHVec3.h"
+#include "Math/Vector/SHVec4.h"
+
+namespace SHADE
+{
+  struct SHSerializationHelper
+  {
+    template <typename ComponentType, std::enable_if_t<std::is_base_of_v<SHComponent, ComponentType>, bool> = true>
+    static std::string SerializeComponentToString(ComponentType* component)
+    {
+      return std::string();
+    }
+
+    template <typename ComponentType, std::enable_if_t<std::is_base_of_v<SHComponent, ComponentType>, bool> = true>
+    static void SerializeComponentToFile(ComponentType* component, std::filesystem::path const& path)
+    {
+    }
+
+    static YAML::Node RTTRToNode(const rttr::variant& var)
+    {
+      YAML::Node node;
+      auto varType = var.get_type();
+      if (varType == rttr::type::get<SHVec4>())
+      {
+        node.SetStyle(YAML::EmitterStyle::Flow);
+        node["X"] = var.convert<SHVec4>().x;
+        node["Y"] = var.convert<SHVec4>().y;
+        node["Z"] = var.convert<SHVec4>().z;
+        node["W"] = var.convert<SHVec4>().w;
+      }
+      else if (varType == rttr::type::get<SHVec3>())
+      {
+        node.SetStyle(YAML::EmitterStyle::Flow);
+        node["X"] = var.convert<SHVec3>().x;
+        node["Y"] = var.convert<SHVec3>().y;
+        node["Z"] = var.convert<SHVec3>().z;
+      }
+      else if (varType == rttr::type::get<SHVec2>())
+      {
+        node.SetStyle(YAML::EmitterStyle::Flow);
+        node["X"] = var.convert<SHVec3>().x;
+        node["Y"] = var.convert<SHVec3>().y;
+      }
+      else if (varType.is_arithmetic())
+      {
+        bool ok = false;
+        if (varType == rttr::type::get<bool>())
+          node = var.to_bool();
+        else if (varType == rttr::type::get<int8_t>())
+          node = var.to_int8(&ok);
+        else if (varType == rttr::type::get<int16_t>())
+          node = var.to_int16(&ok);
+        else if (varType == rttr::type::get<int32_t>())
+          node = var.to_int32(&ok);
+        else if (varType == rttr::type::get<int64_t>())
+          node = var.to_int64(&ok);
+        else if (varType == rttr::type::get<uint8_t>())
+          node = var.to_uint8(&ok);
+        else if (varType == rttr::type::get<uint16_t>())
+          node = var.to_uint16(&ok);
+        else if (varType == rttr::type::get<uint32_t>())
+          node = var.to_uint32(&ok);
+        else if (varType == rttr::type::get<uint64_t>())
+          node = var.to_uint64(&ok);
+        else if (varType == rttr::type::get<float>())
+          node = var.to_float(&ok);
+        else if (varType == rttr::type::get<double>())
+          node = var.to_double(&ok);
+        //else if (varType == rttr::type::get<char>()) //same as uint8_t
+        //    node = var.to_uint8();
+      }
+      else if (varType.is_enumeration())
+      {
+        bool ok = false;
+        auto result = var.to_string(&ok);
+        if (ok)
+        {
+          node = var.to_string();
+        }
+        else
+        {
+          ok = false;
+          auto value = var.to_uint64(&ok);
+          if (ok)
+            node = value;
+          else
+            node = YAML::Null;
+        }
+      }
+      else
+      {
+        auto properties = var.get_type().get_properties();
+        for (auto property : properties)
+        {
+          node[property.get_name().data()] = RTTRToNode(property.get_value(var));
+        }
+      }
+      return node;
+    }
+
+    template <typename ComponentType, std::enable_if_t<std::is_base_of_v<SHComponent, ComponentType>, bool> = true>
+    static YAML::Node SerializeComponentToNode(ComponentType* component)
+    {
+      YAML::Node node{};
+      if (!component)
+        return node;
+
+      auto componentType = rttr::type::get<ComponentType>();
+      node = RTTRToNode(*component);
+
+      return node;
+    }
+
+    template <typename ComponentType, std::enable_if_t<std::is_base_of_v<SHComponent, ComponentType>, bool> = true>
+    static void InitializeProperty(ComponentType* component, rttr::property const& prop, YAML::Node const& propertyNode)
+    {
+      auto propType = prop.get_type();
+      if (propType == rttr::type::get<SHVec4>())
+      {
+        SHVec4 vec{ propertyNode["X"].as<float>(), propertyNode["Y"].as<float>(), propertyNode["Z"].as<float>(), propertyNode["W"].as<float>() };
+        prop.set_value(component, vec);
+      }
+      else if (propType == rttr::type::get<SHVec3>())
+      {
+        SHVec3 vec{ propertyNode["X"].as<float>(), propertyNode["Y"].as<float>(), propertyNode["Z"].as<float>() };
+        prop.set_value(component, vec);
+      }
+      else if (propType == rttr::type::get<SHVec2>())
+      {
+        SHVec2 vec{ propertyNode["X"].as<float>(), propertyNode["Y"].as<float>() };
+        prop.set_value(component, vec);
+      }
+      else if (propType.is_arithmetic())
+      {
+        bool ok = false;
+        if (propType == rttr::type::get<bool>())
+          prop.set_value(component, propertyNode.as<bool>());
+        else if (propType == rttr::type::get<int8_t>())
+          prop.set_value(component, propertyNode.as<int8_t>());
+        else if (propType == rttr::type::get<int16_t>())
+          prop.set_value(component, propertyNode.as<int16_t>());
+        else if (propType == rttr::type::get<int32_t>())
+          prop.set_value(component, propertyNode.as<int32_t>());
+        else if (propType == rttr::type::get<int64_t>())
+          prop.set_value(component, propertyNode.as<int64_t>());
+        else if (propType == rttr::type::get<uint8_t>())
+          prop.set_value(component, propertyNode.as<uint8_t>());
+        else if (propType == rttr::type::get<uint16_t>())
+          prop.set_value(component, propertyNode.as<uint16_t>());
+        else if (propType == rttr::type::get<uint32_t>())
+          prop.set_value(component, propertyNode.as<uint32_t>());
+        else if (propType == rttr::type::get<uint64_t>())
+          prop.set_value(component, propertyNode.as<uint64_t>());
+        else if (propType == rttr::type::get<float>())
+          prop.set_value(component, propertyNode.as<float>());
+        else if (propType == rttr::type::get<double>())
+          prop.set_value(component, propertyNode.as<double>());
+      }
+      else if (propType.is_enumeration())
+      {
+        auto enumAlign = prop.get_enumeration();
+        prop.set_value(component, enumAlign.name_to_value(propertyNode.as<std::string>()));
+      }
+      else
+      {
+        auto properties = propType.get_properties();
+        for (auto property : properties)
+        {
+          InitializeProperty(component, property, propertyNode[property.get_name().data()]);
+        }
+      }
+    }
+
+    template <typename ComponentType, std::enable_if_t<std::is_base_of_v<SHComponent, ComponentType>, bool> = true>
+    static void InitializeComponentFromNode(YAML::Node const& componentsNode, EntityID const& eid)
+    {
+      auto component = SHComponentManager::GetComponent_s<ComponentType>(eid);
+      if (componentsNode.IsNull() && !component)
+        return;
+      auto rttrType = rttr::type::get<ComponentType>();
+      auto componentNode = componentsNode[rttrType.get_name().data()];
+      if (componentsNode.IsNull())
+        return;
+      auto properties = rttrType.get_properties();
+      for (auto const& prop : properties)
+      {
+        if (componentNode[prop.get_name().data()])
+        {
+          InitializeProperty<ComponentType>(component, prop, componentNode[prop.get_name().data()]);
+        }
+      }
+    }
+
+  };
+}
